%Test RNN Clustering
clear;
close all;
%nppc=number of points per cluster
nppc=100;
%Test with 3 clusters
np=nppc*3;
%Threshold
thres=0.8;

%Generate artifical data
rand('state',12);
X = [rand(nppc,3); rand(nppc,3)+1.5; rand(nppc,3)+2.5]; 

dlmwrite('rnn_test.in',X,'delimiter', ' ');

command=['export LD_LIBRARY_PATH=/usr/lib; ./rnn --data=rnn_test.in --dim=3 --n=' num2str(np) ' --thres=' num2str(thres) ' --out=rnn_test.out'];
system(command);

%Read time
time = dlmread('rnn_test.out','',[0 0 0 0]);
%Read ndist
ndist = dlmread('rnn_test.out','',[1 0 1 0]);

%Read labels
labels = round(dlmread('rnn_test.out','',[2 0 2+np-1 0]));

%Number of clusters
nc = dlmread('rnn_test.out','',[2+np 0 2+np 0]);

%Read centroids
centroids = dlmread('rnn_test.out','',[2+np+1 0 2+np+nc 2]);


sprintf('The number of clusters is %d',nc)

%Show in a figure
scatter3(X(:,1),X(:,2),X(:,3),100,labels,'filled')

delete('rnn_test.in');
delete('rnn_test.out');
